#! /usr/bin/env python

########################################
#
# Script to extract EnergyWise data from
# pcap files an send it.
#
#########################################

# Change log level to suppress IPv6 error
import logging
logging.getLogger("scapy.runtime").setLevel(logging.ERROR)

# Import scapy
from scapy.all import *


if len(sys.argv) != 3:
    print "Usage: replay_ew <pcap File> <dest_ip>\n  eg: replay_ew '/root/energywise.pcap' '192.168.1.10'"
    sys.exit(1)
	

# Command-line arguments
pcap = sys.argv[1]
dest_ip = sys.argv[2]

# Generate random source port number
port=RandNum(5024,65535)

# Read pcap file
pkts=rdpcap(pcap)


# Extract first packet from pcap
pkt=pkts[0]

# pkt.load is the raw EnergyWise data
# sending the packet
send(IP(dst=dest_ip)/UDP(sport=[port],dport=[43440])/pkt.load)

