-- ==========================================================
-- Wireshark packet dissector for EnergyWise
--
-- This LUA script must be copied to the Wireshark directory.
-- Then, the LUA script must be called at the end of "init.lua".
-- dofile("EnergyWise.lua")
-- ==========================================================


    energywise_proto = Proto("energywise","EnergyWise","EnergyWise Protocol")

function energywise_proto.dissector(buffer,pinfo,tree)
	

	
    pinfo.cols.protocol = "EnergyWise"
		
	local node = tree:add(energywise_proto, buffer(), "EnergyWise")
	local childnode
	local childnode2
	local childnode3
	local childnode4
	local childnode5
	local childnode6
	local childnode7
	local idx = 0

	  
  if buffer(idx):len() >= 2 then
    node:add(buffer(idx,2), "Unknown: " .. buffer(idx,2))
    idx = idx + 2
    end
	
  if buffer(idx):len() >= 6 then
    node:add(buffer(idx,6), "Pad: " .. buffer(idx,6))
    idx = idx + 6
    end
	
  if buffer(idx):len() >= 2 then
    node:add(buffer(idx,2), "Unknown: " .. buffer(idx,2))
    idx = idx + 2
    end
	
  if buffer(idx):len() >= 2 then
    node:add(buffer(idx,2), "Unknown: " .. buffer(idx,2))
    idx = idx + 2
    end
	
  if buffer(idx):len() >= 20 then
    node:add(buffer(idx,20), "Hash: " .. buffer(idx,20))
    idx = idx + 20
    end
	
  if buffer(idx):len() >= 4 then
    node:add(buffer(idx,4), "Sequence Number: " .. buffer(idx,4):uint())
    idx = idx + 4
	childnode  = node
	childnode2 = node
	childnode3 = node
	childnode4 = node
	childnode5 = node
	childnode6 = node
	childnode7 = node
    end
	
  if buffer(idx):len() >= 32 then 
    node = node:add(buffer(idx,32), "UUID: " .. buffer(idx,32))
    idx = idx + 32
    end
	
	
  if buffer(idx):len() >= 2 then

		childnode:add(buffer(idx,2), "Message Type: " .. buffer(idx,2))
		idx = idx + 2
	
   end

  if buffer(idx):len() >= 1 then
    childnode:add(buffer(idx,1), "Importance: " .. buffer(idx,1):uint())
    idx = idx + 1
    end
	
  if buffer(idx):len() >= 5 then
    childnode:add(buffer(idx,5), "Unknown Field: " .. buffer(idx,5))
    idx = idx + 5
    end
	
  if buffer(idx):len() >= 2 then
    childnode:add(buffer(idx,2), "Length of TLV table: " .. buffer(idx,2):uint())
    idx = idx + 2
    end
	
  if buffer(idx):len() >= 2 then
    childnode:add(buffer(idx,2), "Number of TLVs in table: " .. buffer(idx,2):uint())
    idx = idx + 2
	node = childnode
    end
	
  if buffer(idx):len() >= 24 then
    childnode = childnode:add(buffer(idx,24), "EnergyWise Domain" .. buffer(idx,0))
    idx = idx
    end	
	
  if buffer(idx):len() >= 4 then
    childnode:add(buffer(idx,4), "Type of TLV: " .. string.format("%02x", buffer(idx,4):uint()))
    idx = idx + 4
    end	
	
  if buffer(idx):len() >= 4 then
    childnode:add(buffer(idx,4), "Length of TLV: " .. buffer(idx,4):uint())
    idx = idx + 4
    end		

  if buffer(idx):len() >= 4 then
    childnode:add(buffer(idx,4), "Unknown Field: " .. buffer(idx,4))
    idx = idx + 4
    end		
	
  if buffer(idx):len() >= 12 then
    childnode:add(buffer(idx,12), "EnergyWise Domain Name: " .. buffer(idx,12):string())
    idx = idx + 12
    end	
	
  if buffer(idx):len() >= 28 then
    node = node:add(buffer(idx,28), "EnergyWise Reply To " .. buffer(idx,0))
    idx = idx 
    end
	
  if buffer(idx):len() >= 4 then
    node:add(buffer(idx,4), "Type of TLV: " .. string.format("%02x", buffer(idx,4):uint()))
    idx = idx + 4
    end

  if buffer(idx):len() >= 4 then
    node:add(buffer(idx,4), "Length of TLV: " .. buffer(idx,4):uint())
    idx = idx + 4
    end

  if buffer(idx):len() >= 6 then
    node:add(buffer(idx,6), "Unknown Field: " .. buffer(idx,6))
    idx = idx + 6
    end		

  if buffer(idx):len() >= 2 then
    node:add(buffer(idx,2), "Port: " .. buffer(idx,2):uint())
    idx = idx + 2
    end
	
  if buffer(idx):len() >= 4 then
    node:add(buffer(idx,4), "IP Address: " .. buffer(idx,1):uint() .. "." .. buffer(idx + 1,1):uint() .. "." .. buffer(idx + 2,1):uint() .. "." .. buffer(idx + 3,1):uint())
    idx = idx + 4
    end
	
  if buffer(idx):len() >= 8 then
    node:add(buffer(idx,8), "Unknown Field: " .. buffer(idx,8))
    idx = idx + 8
    end		
	
  if buffer(idx):len() >= 14 then
    childnode2 = childnode2:add(buffer(idx,14), "EnergyWise ??? " .. buffer(idx,0))
    idx = idx
    end	
	
  if buffer(idx):len() >= 4 then
    childnode2:add(buffer(idx,4), "Type of TLV: " .. string.format("%02x", buffer(idx,4):uint()))
    idx = idx + 4
    end	
	
  if buffer(idx):len() >= 4 then
    childnode2:add(buffer(idx,4), "Length of TLV: " .. buffer(idx,4):uint())
    idx = idx + 4
    end
	
  if buffer(idx):len() >= 6 then
    childnode2:add(buffer(idx,6), "Unknown Field: " .. buffer(idx,6))
    idx = idx + 6
    end
	
  if buffer(idx):len() >= 16 then
    childnode3 = childnode3:add(buffer(idx,16), "EnergyWise ??? " .. buffer(idx,0))
    idx = idx
    end	
	
  if buffer(idx):len() >= 4 then
    childnode3:add(buffer(idx,4), "Type of TLV: " .. string.format("%02x", buffer(idx,4):uint()))
    idx = idx + 4
    end	
	
  if buffer(idx):len() >= 4 then
    childnode3:add(buffer(idx,4), "Length of TLV: " .. buffer(idx,4):uint())
    idx = idx + 4
    end
	
  if buffer(idx):len() >= 8 then
    childnode3:add(buffer(idx,8), "Unknown Field: " .. buffer(idx,8))
    idx = idx + 8
    end
	
  if buffer(idx):len() >= 13 then
    childnode4 = childnode4:add(buffer(idx,13), "EnergyWise Name (query) " .. buffer(idx,0))
    idx = idx
    end	
	
  if buffer(idx):len() >= 4 then
    childnode4:add(buffer(idx,4), "Type of TLV: " .. string.format("%02x", buffer(idx,4):uint()))
    idx = idx + 4
    end	
	
  if buffer(idx):len() >= 4 then
    childnode4:add(buffer(idx,4), "Length of TLV: " .. buffer(idx,4):uint())
    idx = idx + 4
    end
	
  if buffer(idx):len() >= 4 then
    childnode4:add(buffer(idx,4), "Unknown Field: " .. buffer(idx,4))
    idx = idx + 4
    end
	
  if buffer(idx):len() >= 1 then
    childnode4:add(buffer(idx,1), "Name: " .. buffer(idx,1):string())
    idx = idx + 1
    end
	
  if buffer(idx):len() >= 13 then
    childnode5 = childnode5:add(buffer(idx,13), "EnergyWise Level (query) " .. buffer(idx,0))
    idx = idx
    end	
	
  if buffer(idx):len() >= 4 then
    childnode5:add(buffer(idx,4), "Type of TLV: " .. string.format("%02x", buffer(idx,4):uint()))
    idx = idx + 4
    end	
	
  if buffer(idx):len() >= 4 then
    childnode5:add(buffer(idx,4), "Length of TLV: " .. buffer(idx,4):uint())
    idx = idx + 4
    end
	
  if buffer(idx):len() >= 4 then
    childnode5:add(buffer(idx,4), "Unknown Field: " .. buffer(idx,4))
    idx = idx + 4
    end	
	
  if buffer(idx):len() >= 1 then
    childnode5:add(buffer(idx,1), "Level: " .. buffer(idx,1):uint())
    idx = idx + 1
    end	
	
  if buffer(idx):len() >= 16 then
    childnode6 = childnode6:add(buffer(idx,16), "EnergyWise ??? " .. buffer(idx,0))
    idx = idx
    end	
	
  if buffer(idx):len() >= 4 then
    childnode6:add(buffer(idx,4), "Type of TLV: " .. string.format("%02x", buffer(idx,4):uint()))
    idx = idx + 4
    end	
	
  if buffer(idx):len() >= 4 then
    childnode6:add(buffer(idx,4), "Length of TLV: " .. buffer(idx,4):uint())
    idx = idx + 4
    end
	
  if buffer(idx):len() >= 8 then
    childnode6:add(buffer(idx,8), "Unknown Field: " .. buffer(idx,8))
    idx = idx + 8
    end
	
  if buffer(idx):len() >= 13 then
    childnode7 = childnode7:add(buffer(idx,13), "EnergyWise ???" .. buffer(idx,0))
    idx = idx
    end	
	
  if buffer(idx):len() >= 4 then
    childnode7:add(buffer(idx,4), "Type of TLV: " .. string.format("%02x", buffer(idx,4):uint()))
    idx = idx + 4
    end	
	
  if buffer(idx):len() >= 4 then
    childnode7:add(buffer(idx,4), "Length of TLV: " .. buffer(idx,4):uint())
    idx = idx + 4
    end
	
  if buffer(idx):len() >= 4 then
    childnode7:add(buffer(idx,4), "Unknown Field: " .. buffer(idx,4))
    idx = idx + 4
    end	
	
  if buffer(idx):len() >= 1 then
    childnode7:add(buffer(idx,1), "Unknown Value: " .. buffer(idx,1))
    idx = idx + 1
    end
	
end


       -- Register this dissector
tcp_table = DissectorTable.get("tcp.port")
tcp_table:add(43440,energywise_proto)